; Program name: PESHiELD Unpacker
; Version:      2.4
; Author:       Unknown One
; Target:       PESHiELD versions 0.1b, 0.1c, 0.1d, 0.2b, 0.2b2, and 0.25 encrypted files
; Music:        ???
; Greetings to: everyone :)
; Special greets to: ANAKiN, Iczelion, tHE EGOiSTE, totnak, VAG, DAEMON, r!sc

; History
; 11-08-2000    xx:xx   Developement of 32-bit version started. Thanks to r!sc and Daemon for 
;                       win32asm sources of how to manage with memory and files
; 11-09-2000    8:50am  Fixed shit lame bug in unpacking one of internal layers
;                       in PESHiELD 0.2b (missing 'H' at the end of hex number)
;               09:23am Sections decryptor added. Stoppped working on PESHiELD for today
; 11-10-2000    09:25am Started working on import section decryption
;               10:30am Unpacker finished. Testing started
;               11:08am Found bug in imports rebuilding. Continue testing and debugging
;               12:08pm Fixed bug in imports rebuilding
;               01:00pm Unpacker crashed when trying to decrypt w32dasm.exe crypted twice :(
;                       Continue tests and debugging
;               02:00pm Found that there is bug in decrypting sections. I dont know where it is
;               11:00pm Sleeping and dreaming... and found a bug in decrypting sections :)
; 11-12-2000    05:38am After 5 hours of coding and trying to find where is the bug in
;                       decrypting I started TRW and traced few lines in the twice PESHiELD-ed
;                       w32dasm.exe file. Why looking where is the difference in the decrypted
;                       layers I found that decrypting one section may affect part of the
;                       following one (decrypting is done using the physical length of 
;                       the section but sometimes it starts from an offset in it)
; 11-13-2000    09:33am Started to fix the decrypting of sections. Recoded new RVA2FO procedure
;                       and now it returns NULL if the given RVA is not in the file
;               12:00pm Rewritten the RVA2FO procedure and all tests are successfull :)
;               03:30pm GUI added. Thanks to tARG0N/cRO for the nice gfx :)
; 11-14-2000	03:40pm	Some improvements to GUI version
;			PE file checksum added (credits to tE!)
;		03:00pm	Sent to exelist 
; 11-16-2000	03:50pm	Adding displaying of unpacking process
; ...			Working on different cryptors, improving PE knowledge 
; ...			and win32asm skills
; 11-27-2000	01:25pm	Finished the analize of PESHiELD reloc compress routine
; ...			Had been ill (influenza shits) :(
; 12-01-2000	11:20am	Added relocations decompress and sort routine
;		01:00pm	Added valid reloc table create routine
;		07:00pm	Starting to drink... (Q: Why? A: It's a secret ;))
; 12-03-2000	06:20am	Stopped drinking... (I am not sure for the hour). Status: dead
; 12-04-2000	08:50am	Back from death - coding decryptor for NoodleCrypt 2 (lame shit)
; 12-05-2000	11:45am	Added PESHiELD 0.25 support (Hi, Iczelion! :) The decrypting
;			works perfect! The only thing left to do is the resource
;			rebuilding and adding old PESHiELD versions support
; 12-07-2000	01:30pm	Started analizing the polymorph decryptor layer of PESHiELD 0.1d
;			Found an easy way to emulate it. Started coding of detect procedure
; 12-08-2000	10:00am	Continued work on coding of the detection of polymorph layer
;		12:10pm	Detection and emulation decoding works on test file but fails on
;			encrypted w32dasm (what a fucking .exe for protectors/unpackers *g*)
;			Decrypting sections and restoring original entry point works.
;		01:00pm	After some additional analize found that decryption length is not
;			always the same and added some detection and calculation of decrypt
;			size. Now mutation decrypting works for all files I tested! WOW,
;			it was a lot work to code and fix that - polymorph engines are nice
;			thing (I can recommend them to all protector authors)
;		01:30pm	Fixed small bug if file is not crypted with PESHiELD 0.1d
;		01:43pm	Added support procedure for PESHiELD 0.1d in main program. I need
;			other PESHiELD versions (I have 0.25, 0.2b2, 0.2b, 0.1d). If you
;			have any other version, please send it to unknone@mail.com
;		02:00pm	Found that some multiple layers encrypted files cannot be decrypted
;			OK. They even cannot run so this is not bug in my unpacker (G-RoM's
;			PE-SHiELD ReMoVeR V0.14 failed too - probably entered endless loop
;			while "Checking signature"). All that concerns for files that have
;			at least one PESHiELD v0.1d layer! G-RoM's unpacker didn't recognize
;			twice encrypted with v0.1d file, mine works OK with it. All problems
;			I got came from the fact I used different PESHiELD versions to encrypt
;			the test file but I will say it again: it is not my fault!
;		04:20pm	Found bad decryption on one UPX-ed file.
;			Sometimes PESHiELD adds in it's section array wrong info about section.
;			By skipping invalid RVA's (the function RVA2FO do the work again ;)
;			decrypting works. The encrypted file doesn't run, but the decrypted
;			with unPES does it OK.
; 03-09-2001	08:22pm	Looking at PESHiELD 0.1b and 0.1c layer (finally I got some time to
;			work on this little unpacker again ;)
;		08:29pm	The polymorph decryptor I wrote for PESHiELD v0.1d works with these
;			older versions :)))
;		09:26pm	Back to work - analizing the PESHiELD layer (the real one)...
;		10:20pm	Stopped working - have to sleep a little bit
; 03-11-2001	05:30pm	Finishing the unpacker - it took me few hours to fix some lame bugs in
;			my coding (not the real unpacking process) and there it is :)
;		06:33pm	Added another option that clears the PESHiELD 0.1x layer from file and
;			the result is smaller file. Always use with caution this option because
;			if there are ANY redirected resources in the sections which are cleared
;			(for example file crypted with PESHiELD 0.1c then with 0.2b2) the file
;			will become unworking because no resources rebuilding is done.
        .586p
        .model  flat,stdcall
        locals
        jumps

UNICODE =       0
        include w32.inc                 ; Very usefull include file
        include unpes.ash               ; Resource IDs

crlf    equ     0dh,0ah


        extrn   IsDlgButtonChecked:proc
        extrn   _wsprintfA:proc
        extrn   CheckDlgButton:proc

;###### Data section #################################################
        .data
hInst           dd      ?               ; Module handle
hMain           dd      ?               ; Main dialog hwnd

hInfoBox	dd	?		; InfoBox hwnd

wc      WNDCLASSEX              <0>     ; Main window structure
msg     MSG                     <0>     ; Message structure

szClassName     db      'UNPES_CLASS',00h


szInfoBoxFnt	db	'FixedSys',00h

szAboutMess     db      'PESHiELD v0.1x/v0.2x unpacker',crlf
                db      'Coded by Unknown One',crlf
                db      'e-mail: unknone@mail.com',00h
szAbout         db      'About',00h

szInfo          db      'Info',00h
szPEChkSum      db      'Recalculating PE file checksum is used on drivers that run on WinNT',crlf
                db      'and Win2000. Using this option you may get unworking file',crlf
                db      'if in exe left another packer/protector (like PESHiELD) which',crlf
                db      'uses heuristic virus checks (CRC of PE header is often used)',crlf
                db      'and the execution of the file can stop due to false virus alarm.',crlf
                db      crlf
                db      'All credits for this routine go to tHE EGOiSTE!',crlf
                db      crlf
                db      'Are you sure you want to turn ON this option?',00h

szChangeFlags   db      'Changing flags of code section gives possibility to disassemble',crlf
                db      'the unpacked file with W32Dasm by URSoft. This may cause',crlf
                db      'unworking file if in exe file left another packer/protector',crlf
                db      'which uses heuristic virus checks (CRC of PE header is often',crlf
                db      'used) and the execution can be stopped due to false alarm.',crlf
                db      crlf
                db      'Are you sure you want to turn ON this option?',00h

szRemoveLayer	db	'Removing the PESHiELD 0.1x layer may produce unworking file if',crlf
		db	'it has another layer(s) after the removed one and this (these)',crlf
		db	'layer(s) contain ANY redirected resources (the current version',crlf
		db	'does not rebuild resources)! You can safely use this option if',crlf
		db	'the file is encrypted ONLY with PESHiELD versions 0.1x',crlf
		db	crlf
		db	'Are you sure you want to turn ON this option?',00h

;###### Code section #################################################
        .code
start   proc
        call    GetModuleHandleA, NULL  ; Get module handle and save it
        mov     hInst, eax              ; for later use

        call    init_unpacker

; Initialize the WndClass (Window Class) structure
        mov     wc.wc_cbSize, WNDCLASSEX_
        mov     wc.wc_style, CS_HREDRAW + CS_VREDRAW
        mov     wc.wc_lpfnWndProc, offset MainWndProc
        mov     wc.wc_cbClsExtra, 0
        mov     wc.wc_cbWndExtra, DLGWINDOWEXTRA
        mov     eax, hInst
        mov     wc.wc_hInstance, eax

; Load main icon from resource
        call    LoadIcon, hInst, IDI_ICON1
        mov     wc.wc_hIcon, eax
        mov     wc.wc_hIconSm, eax

; Load a default cursor
        call    LoadCursor,NULL, IDC_ARROW
        mov     wc.wc_hCursor, eax

        mov     wc.wc_hbrBackground, COLOR_BACKGROUND
        mov     wc.wc_lpszMenuName, NULL
        mov     wc.wc_lpszClassName, offset szClassName
        call    RegisterClassEx, offset wc

; Create main window
        call    CreateDialogParam, hInst, offset szClassName, 0, NULL, 0
        mov     hMain, eax

; Get some HWNDs
	call	GetDlgItem, hMain, IDC_INFOBOX
	mov	hInfoBox, eax


; Change font of the list box
	call	CreateFont, 10, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, offset szInfoBoxFnt
	or	eax,eax
	jz	cant_change_font

	call	SendMessage, hInfoBox, WM_SETFONT, eax, 0

cant_change_font:

;###### Message loop #################################################
msg_loop:
        call    GetMessage, offset msg, 0,0,0
        cmp     ax, 0
        je      end_loop

        call    IsDialogMessage, hMain, offset msg
        cmp     eax, TRUE
        jz      msg_loop

        call    TranslateMessage, offset msg
        call    DispatchMessage, offset msg
        jmp     msg_loop

end_loop:
        call    ExitProcess, msg.ms_wParam
start   endp

;###### WndProc ######################################################
MainWndProc     proc    USES ebx edi esi, hwnd:DWORD, wmsg:DWORD, \
                        wparam:DWORD, lparam:DWORD
        cmp     wmsg, WM_DESTROY        ; Close program?
        je      @@wmdestroy

        cmp     wmsg, WM_COMMAND        ; Is control pressed
        je      @@wmcommand

; Call default window procedure to handle the other messages
        call    DefWindowProc, hwnd,wmsg,wparam,lparam
        jmp     @@finish

@@wmcommand:
        cmp     word ptr [wparam], IDC_EXIT
        jne     @@wmc_1
        call    ExitProcess, 0

@@wmc_1:
        cmp     word ptr [wparam], IDC_ABOUT
        jne     @@wmc_2
        call    MessageBox, NULL, offset szAboutMess, offset szAbout, \
                MB_ICONQUESTION or MB_TASKMODAL

        jmp     @@finish

@@wmc_2:
        cmp     word ptr [wparam], IDC_OPENNAME ; '...' button pressed? (get open file name)
        jne     @@wmc_3

        mov     ofn_struc.on_lStructSize,OPENFILENAME_
        mov     ofn_struc.on_lpstrFilter,offset ofn_filter
        mov     ofn_struc.on_lpstrFile,offset f_name
        mov     ofn_struc.on_lpstrTitle,offset ofn_title
        mov     ofn_struc.on_nMaxFile,0200h
        mov     ofn_struc.on_Flags,OFN_FILEMUSTEXIST or \
                                   OFN_PATHMUSTEXIST or OFN_LONGNAMES or\
                                   OFN_EXPLORER or OFN_HIDEREADONLY
        call    GetOpenFileNameA, offset ofn_struc
        or      eax,eax
        jz      @@wmc_2_1
        
        call    SetDlgItemTextA, hMain, IDC_INPUTFNAME, offset f_name

@@wmc_2_1:
        jmp     @@finish

@@wmc_3:
        cmp     word ptr [wparam], IDC_UNPACK   ; Unpack file button?
        jne     @@wmc_4

        call    GetDlgItemTextA, hMain, IDC_INPUTFNAME, offset f_name, 0200h
        mov	layers_num,00h
        call    unpack_peshield
        jmp     @@finish

;-------
@@wmc_4:
        cmp     word ptr [wparam], IDC_PECHECKSUM
        jne     @@wmc_5
        call    IsDlgButtonChecked, hMain, IDC_PECHECKSUM
        mov     calc_pe_chksum,00h
        cmp     eax, BST_CHECKED
        jne     @@wmc_4_1
        call    MessageBox, NULL, offset szPEChkSum, offset szInfo, \
                MB_YESNO or MB_TASKMODAL or MB_ICONWARNING
        cmp     eax,IDNO
        je      @@wmc_4_1

        inc     calc_pe_chksum
        jmp     @@finish
@@wmc_4_1:
        call    CheckDlgButton, hMain, IDC_PECHECKSUM, BST_UNCHECKED
        jmp     @@finish

;-------
@@wmc_5:
        cmp     word ptr [wparam], IDC_MULTILAYER
        jne     @@wmc_6
        call    IsDlgButtonChecked, hMain, IDC_MULTILAYER
        mov     layer_confirm,00h
        cmp     eax, BST_CHECKED
        jne     @@wmc_5_1
        inc     layer_confirm
        jmp     @@finish
@@wmc_5_1:
        jmp     @@finish

;-------
@@wmc_6:
        cmp     word ptr [wparam], IDC_CHGFLAGS
        jne     @@wmc_7
        call    IsDlgButtonChecked, hMain, IDC_CHGFLAGS
        mov     chg_codeflags,00h
        cmp     eax, BST_CHECKED
        jne     @@wmc_6_1
        call    MessageBox, NULL, offset szChangeFlags, offset szInfo, \
                MB_YESNO or MB_TASKMODAL or MB_ICONWARNING
        cmp     eax,IDNO
        je      @@wmc_6_1
        inc     chg_codeflags
        jmp     @@finish
@@wmc_6_1:
        call    CheckDlgButton, hMain, IDC_CHGFLAGS, BST_UNCHECKED
        jmp     @@finish

;-------
@@wmc_7:
        cmp     word ptr [wparam], IDC_REMOVELAYER
        jne     @@wmc_8
        call    IsDlgButtonChecked, hMain, IDC_REMOVELAYER
        mov     remove_layers,00h
        cmp     eax, BST_CHECKED
        jne     @@wmc_7_1
        call    MessageBox, NULL, offset szRemoveLayer, offset szInfo, \
                MB_YESNO or MB_TASKMODAL or MB_ICONWARNING
        cmp     eax,IDNO
        je      @@wmc_7_1
        inc     remove_layers
        jmp     @@finish
@@wmc_7_1:
        call    CheckDlgButton, hMain, IDC_REMOVELAYER, BST_UNCHECKED
        jmp     @@finish

;-------
@@wmc_8:
        cmp     word ptr [wparam], IDC_CONFIRM_REMOVE
        jne     @@wmc_9
        call    IsDlgButtonChecked, hMain, IDC_CONFIRM_REMOVE
        mov     remove_confirm,00h
        cmp     eax, BST_CHECKED
        jne     @@wmc_8_1
        inc     remove_confirm
        jmp     @@finish
@@wmc_8_1:
        jmp     @@finish

;-------
@@wmc_9:
        jmp     @@finish


; WM_DESTROY
@@wmdestroy:
        call    PostQuitMessage, 0
        mov     eax, 0
        jmp     @@finish

@@finish:
        ret
MainWndProc     endp

;###### Unpacker data ################################################
        .data

ofn_struc       OPENFILENAME    <>
ofn_filter      db      'Executable file',00h,'*.exe',00h,00h
ofn_title       db      'Select file to unpack',00h
f_name          db      200h dup(?)
f_handle        dd      ?
f_size          dd      ?
read_len        dd      ?
write_len       dd      ?

outfname        db      'out.exe',00h

layers_num	dd	?

buffer          dd      ?

pe_header_ptr   dd      ?
sections_start  dd      ?
entry_addr      dd      ?
image_base      dd      ?
section_size    dd      ?

ver_02b2        equ     01h
ver_02b         equ     02h
ver_025		equ	03h
ver_01d		equ	04h
ver_01c		equ	05h
ver_01b		equ	06h
ver_01beta	equ	07h
ver_01unknown	equ	08h
peshield_ver    db      ?

; PESHiELD layers info
layer2_ofs      dd      ?
layer2_magic    dd      ?
layer2_size     dd      ?
layer2_subsize  dd      ?

layer3_ofs      dd      ?
layer3_size     dd      ?
layer4_ofs      dd      ?
layer4_size     dd      ?
layer5_ofs      dd      ?
layer5_size     dd      ?
layer6_ofs      dd      ?
layer6_size     dd      ?
layer7_ofs      dd      ?
layer7_size     dd      ?
layer8_ofs      dd      ?
layer8_size     dd      ?
layer9_ofs      dd      ?
layer9_size     dd      ?
layer9_magic    db      ?

; Messages
not_mz_err      db      'Not valid EXE file (''MZ'' signature does not present)!',00h
not_pe_err      db      'Not valid PE file (''PE'' signature does not present)!',00h

calc_pe_chksum  db      00h
chg_codeflags   db      00h
layer_confirm   db      00h
remove_layers	db	00h
remove_confirm	db	00h

szLayerConfirm  db      'One PESHiELD layer is unpacked. Do you want',crlf
                db      'to unpack the next one (if exists)?',00h
szRemoveConfirm	db	'PESHiELD 0.1x layer found. Do you want to',crlf
		db	'remove it from the file (DANGEROUS!)?',00h

; Info box messages
nfo_opening	db	'Opening file...',00h
nfo_openok	db	'File opened OK',00h
nfo_cantopen	db	'Error opening input file!',00h
nfo_allocmem	db	'Allocating memory buffer...',00h
nfo_alloc_ok	db	'Memory allocated OK',00h
nfo_cantalloc	db	'Cannot allocate memory!',00h
nfo_reading	db	'Reading file...',00h

nfo_unpack_ok	db	'File successfully unpacked!',00h
nfo_unpack_bad	db	'Not known PESHiELD layer(s) found!',00h


nfo_pesh01unknown	db	'PESHiELD version: 0.1 unknown',00h	; Send it to me, please
nfo_pesh01b	db	'PESHiELD version: 0.1b',00h
nfo_pesh01c	db	'PESHiELD version: 0.1c',00h
nfo_pesh01d	db	'PESHiELD version: 0.1d',00h
nfo_pesh02b	db	'PESHiELD version: 0.2b',00h
nfo_pesh02b2	db	'PESHiELD version: 0.2b2',00h
nfo_pesh025	db	'PESHiELD version: 0.25',00h

nfo_entrypoint	db	'Entry point     : %0.8X',00h
nfo_layermum	db	'Layer number    : %d',00h
nfo_importaddr	db	'Import table at : %0.8X',00h

nfo_separator	db	'---------------------------',00h

nfo_relocs_ok	db	'Relocs unpacked OK!',00h

nfo_temp_str	db	100h dup(?)


;###### Unpacker code ################################################
        .code
init_unpacker   proc
        mov     calc_pe_chksum,00h
        mov     chg_codeflags,00h
        mov     layer_confirm,00h
        mov	layers_num,00h
	mov	remove_layers,00h
	mov	remove_confirm,00h
        ret
init_unpacker   endp

; Unpack PESHiELD-ed file
; Supported versions: 0.2b, 0.2b2
unpack_peshield proc
        pushad

	call	infobox_clear

	call	infobox_additem, offset nfo_opening, 0

        call    CreateFileA, offset f_name, GENERIC_READ+GENERIC_WRITE,\
                             NULL,NULL,\
                             OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL
                             
        cmp     eax,INVALID_HANDLE_VALUE
        jne     open_ok

	call	infobox_additem, offset nfo_cantopen, 0

        jmp     exit

;------ File is opened OK
open_ok:
        mov     f_handle,eax

	call	infobox_additem, offset nfo_openok, 0

;------ Load file in memory
        call    GetFileSize, f_handle, 00h
        mov     f_size,eax

	call	infobox_additem, offset nfo_allocmem, 0

        call    GlobalAlloc, GMEM_FIXED, f_size ; Allocate memory
        or      eax,eax
        jnz     mem_alloc_ok

        call    CloseHandle, f_handle

	call	infobox_additem, offset nfo_cantalloc, 0

        jmp     exit

;------ Memory allocated OK
mem_alloc_ok:
        mov     buffer,eax


	call	infobox_additem, offset nfo_alloc_ok, 0
	call	infobox_additem, offset nfo_reading, 0

        call    ReadFile, f_handle, buffer, f_size, offset read_len, NULL

        call    CloseHandle, f_handle           ; Close input file handle

;------ Check for valid EXE file
check_valid_exe:
        mov     edx,buffer                      ; EDI points to read buffer
        cmp     word ptr [edx],'MZ'
        jz      exe_ok
        cmp     word ptr [edx],'ZM'
        jz      exe_ok

	call	infobox_additem, offset not_mz_err, 0
        jmp     free_mem_exit

exe_ok:
;------ Check for valid PE file
        add     edx,dword ptr [edx+003ch]       ; EDX -> PE header
        cmp     word ptr [edx],'EP'             ; PE file?
        jz      pe_ok

	call	infobox_additem, offset not_pe_err, 0
        jmp     free_mem_exit

pe_ok:
        mov     pe_header_ptr,edx

        mov     eax,dword ptr [edx+0034h]       ; Get image base and save it for later use
        mov     image_base,eax                  ;

;###### UNPACKING START ##############################################

        .radix  16d                             ; Too many hex values

unpack_one_layer:
	call	infobox_additem, offset nfo_separator, 0

        mov     eax,dword ptr [edx+0028h]       ; EAX points to entry point of program
        call    rva2fo
        mov     esi,eax                         ; ESI points to entry point in memory

        mov     entry_addr,esi

	mov	ebp,eax				; EBP is entry for next call
	call	check_old_peshield		; First check for old version
;	cmp	al,02h				; Error decrypting sections?
;	je	write_file			; If so - exit

	cmp	al,00h				; Decrypt OK?
	je	check_new_ver			; Go show info and ask for next layer

	cmp	al,ver_01b			; PESHiELD v0.1b?
	jne	@@show_v01c

	call	infobox_additem, offset nfo_pesh01b, 0
	jmp	@@show_old_ver_num

@@show_v01c:
	cmp	al,ver_01c			; PESHiELD v0.1c?
	jne	@@show_v01d

	call	infobox_additem, offset nfo_pesh01c, 0
	jmp	@@show_old_ver_num

@@show_v01d:
	cmp	al,ver_01d			; PESHiELD v0.1d?
	jne	@@show_v01x_unknown

	call	infobox_additem, offset nfo_pesh01d, 0
	jmp	@@show_old_ver_num

@@show_v01x_unknown:
	call	infobox_additem, offset nfo_pesh01unknown, 0


@@show_old_ver_num:
	inc	layers_num			; Increase layers number
	call	_wsprintfA, offset nfo_temp_str, offset nfo_layermum, layers_num
	add	esp,000ch
	call	infobox_additem, offset nfo_temp_str, 0

	jmp	header_ok

check_new_ver:
; Check for PESHiELD layer
        cmp     dword ptr [esi],0000e860h       ; First instruction(s) of PESHiELD 0.2b2
        jne     not_peshield_02b
        cmp     dword ptr [esi+0006h],'KANA'    ; Check for 'ANAKiN' ID
        jne     not_peshield_02b
        cmp     byte ptr [esi+0016h],031h       ; Offset of 1st internal level is 0031h
        je      peshield_02bfound


not_peshield_02b:
	cmp	dword ptr [esi],002be860h	; Check if ver 0.25 (Hi, Icz! :)
	jne	no_peshield_025

;	cmp	dword ptr [esi+0031h],06ed835dh	; pop ebp; sub ebp,0006h
;	jne	no_peshield_025			;

	cmp	byte ptr [esi+003bh],56h	; Offset of 1st internal layer is 56h
	je	pesh_025			; Go decrypt first layer

no_peshield_025:
        jmp     write_file

peshield_02bfound:

; Decrypt the first mutated layer to check what is the version of PESHiELD - 0.2b2 or 0.2b
        mov     ebp, esi                        ; EBP points to PESHiELD layer
        lea     esi, dword ptr [ebp+00000031h]  ; ESI points to data that will be decrypted
        mov     ebx, dword ptr [ebp+001bh]      ; length of processed data
u1:
        mov     dl, byte ptr [esi+ebx]
        xor     dl, bl

; Emulate the first mutated instruction
        mov     ax,word ptr [ebp+0025h]         ; Get the mutator byte and data
        call    mut_emulate                     ; Emulate the mutated operation

; Emulate the second mutated instruction
        mov     ax,word ptr [ebp+0028h]         ; Get the mutator byte and data
        call    mut_emulate                     ; Analyze and emulate

        mov     byte ptr [esi+ebx], dl          ; Store decrypted byte
        dec     ebx
        jne     u1

;------ Check for 0.2b and 0.2b2 versions which differs in 2nd layer unpack length
        cmp     dword ptr [ebp+004eh],043ch     ; v0.2b2?
        je      pesh_02b2
        cmp     dword ptr [ebp+004eh],03b8h     ; v0.2b?
        je      pesh_02b
        jmp     not_peshield_02b

pesh_025:

; First decrypt the mutated layer of v0.25
        mov     ebp, esi                        ; EBP points to PESHiELD layer
        lea     esi, dword ptr [ebp+0056h]	; ESI points to data that will be decrypted
        mov     ebx, dword ptr [ebp+0040h]      ; length of processed data
u1_1:
        mov     dl, byte ptr [esi+ebx]
        xor     dl, bl

; Emulate the first mutated instruction
        mov     ax,word ptr [ebp+004ah]         ; Get the mutator byte and data
        call    mut_emulate                     ; Emulate the mutated operation

; Emulate the second mutated instruction
        mov     ax,word ptr [ebp+004dh]         ; Get the mutator byte and data
        call    mut_emulate                     ; Analyze and emulate

        mov     byte ptr [esi+ebx], dl          ; Store decrypted byte
        dec     ebx
        jne     u1_1

; Setup layer data
	inc	layers_num			; Increase layers number
	call	_wsprintfA, offset nfo_temp_str, offset nfo_layermum, layers_num
	add	esp,000ch
	call	infobox_additem, offset nfo_temp_str, 0


        mov     peshield_ver,ver_025

        mov     layer2_ofs,12b3h

        mov     edx,dword ptr [ebp+12b7h]
        mov     layer2_magic,edx
        mov     layer2_size,0469h
        mov     layer2_subsize,0110h

        mov     layer3_ofs,0138h
        mov     layer3_size,00c1h

        mov     layer4_ofs,015ch
        mov     layer4_size,009dh

        mov     layer5_ofs,0184h
        mov     layer5_size,0075h

        mov     layer6_ofs,01aeh
        mov     layer6_size,004bh

        mov     layer7_ofs,01d4h
        mov     layer7_size,0025h

        mov     layer8_ofs,01feh
        mov     layer8_size,10b9h

        mov     layer9_ofs,0402h
        mov     layer9_size,00a1h

	call	infobox_additem, offset nfo_pesh025, 0

        jmp     go_decrypt


pesh_02b2:
	inc	layers_num			; Increase layers number
	call	_wsprintfA, offset nfo_temp_str, offset nfo_layermum, layers_num
	add	esp,000ch
	call	infobox_additem, offset nfo_temp_str, 0


        mov     peshield_ver,ver_02b2

        mov     layer2_ofs,11d7h

        mov     edx,dword ptr [ebp+11dbh]
        mov     layer2_magic,edx
        mov     layer2_size,043ch
        mov     layer2_subsize,00e8h

        mov     layer3_ofs,0110h
        mov     layer3_size,00c1h

        mov     layer4_ofs,0134h
        mov     layer4_size,009dh

        mov     layer5_ofs,015ch
        mov     layer5_size,0075h

        mov     layer6_ofs,0186h
        mov     layer6_size,004bh

        mov     layer7_ofs,01ach
        mov     layer7_size,0025h

        mov     layer8_ofs,01d6h
        mov     layer8_size,1005h

        mov     layer9_ofs,039dh
        mov     layer9_size,00a1h

	call	infobox_additem, offset nfo_pesh02b2, 0

        jmp     go_decrypt

pesh_02b:
	inc	layers_num			; Increase layers number
	call	_wsprintfA, offset nfo_temp_str, offset nfo_layermum, layers_num
	add	esp,000ch
	call	infobox_additem, offset nfo_temp_str, 0

        mov     peshield_ver,ver_02b

        mov     layer2_ofs,0fb9h

        mov     edx,dword ptr [ebp+0fbdh]
        mov     layer2_magic,edx
        mov     layer2_size,03b8h
        mov     layer2_subsize,00dah

        mov     layer3_ofs,0102h
        mov     layer3_size,00c1h

        mov     layer4_ofs,0126h
        mov     layer4_size,009dh

        mov     layer5_ofs,014eh
        mov     layer5_size,0075h

        mov     layer6_ofs,0178h
        mov     layer6_size,004bh

        mov     layer7_ofs,019eh
        mov     layer7_size,0025h

        mov     layer8_ofs,01c8h
        mov     layer8_size,0df5h

        mov     layer9_ofs,0368h
        mov     layer9_size,00a1h

	call	infobox_additem, offset nfo_pesh02b, 0

go_decrypt:

;------ Layer 2
        std
        mov     esi,ebp
        add     esi,layer2_ofs
        mov     edi, esi

        mov     edx,0ffffffffh          ; mov dx,cs; lsl edx,edx (load selector limit)

        xor     edx, layer2_magic


        mov     ecx, layer2_size        ; Bytes to decrypt (1084 dec)

u2:
        push    ecx
        push    eax
        mov     ecx, layer2_subsize

;------ Key calculation using check sum
u2_1:
        mov     eax,0ffffffffh
        add     edx, eax
        dec     ebp
        add     edx, dword ptr [ebp+ecx]
        inc     ebp
        rol     edx, cl
        dec     ecx
        jne     u2_1

        pop     eax
        pop     ecx

        xor     eax,eax

        xor     eax, dword ptr [esi]
        sub     esi, 00000004h
        xor     eax, edx
        add     edx, eax

        cmp     peshield_ver,ver_02b2
        je      u2_02b2

        cmp	peshield_ver,ver_025
        je	u2_025

u2_02b:	mov     dword ptr [ebp+000000cah], edx
        jmp     u2_3

u2_02b2:mov     dword ptr [ebp+000000d8h], edx
	jmp	u2_3

u2_025:	mov	dword ptr [ebp+00000100h],edx

u2_3:
        rol     edx, cl
        stosd
        cmp	peshield_ver,ver_025
        je	u24_025


u24_02b:inc     dword ptr [ebp+0062h]           ; Same offset for 0.2b and 0.2b2 versions
	jmp	u2_4

u24_025:inc	dword ptr [ebp+0087h]

u2_4:
        dec     ecx
        jne     u2


;------ Layer 3
        cld
        mov     esi,ebp

        add     esi,layer3_ofs
        mov     ecx,layer3_size

        cmp     peshield_ver,ver_02b2
        je      u3_02b2

	cmp	peshield_ver,ver_025
	je	u3_025

u3_02b: mov     al,byte ptr [ebp+00f5h]
        jmp     u3

u3_02b2:
        mov     al,byte ptr [ebp+0103h]
	jmp	u3

u3_025:	mov	al,byte ptr [ebp+012bh]

u3:     cmp	peshield_ver,ver_025
	je	u3_d025

	xor     byte ptr [esi], al		; XOR for versions 0.2b2 and 0.2b
	jmp	u3_loop

u3_d025:
	sub	byte ptr [esi], al		; SUB for version 0.25

u3_loop:
        inc     esi
        dec     ecx
        jne     u3

;------ Layer 4
        cld
        mov     esi,ebp
        add     esi,layer4_ofs
        mov     ecx,layer4_size

        cmp     peshield_ver,ver_02b2
        je      u4_02b2

	cmp	peshield_ver,ver_025
	je	u4_025

u4_02b:	mov     al,byte ptr [ebp+011bh]
        jmp     u4

u4_02b2:mov     al,byte ptr [ebp+0129h]
	jmp	u4

u4_025:	mov	al,byte ptr [ebp+0151h]


u4:	xor     byte ptr [esi], al		; XOR for 0.2b, 0.2b2, 0.25
        inc     esi
        dec     ecx
        jne     u4

;------ Layer 5
        cld
        mov     esi,ebp
        add     esi,layer5_ofs
        mov     ecx,layer5_size

        cmp     peshield_ver,ver_02b2
        je      u5_02b2

	cmp	peshield_ver,ver_025
	je	u5_025

u5_02b:	mov     al,byte ptr [ebp+0140h]
        jmp     u5

u5_02b2:mov     al,byte ptr [ebp+014eh]
	jmp	u5

u5_025:	mov	al,byte ptr [ebp+0176h]

u5:	cmp	peshield_ver,ver_025
	je	u5_d025

	xor     byte ptr [esi], al
	jmp	u5_loop
u5_d025:
	add	byte ptr [esi],al

u5_loop:
        inc     esi
        dec     ecx
        jne     u5

;------ Layer 6
        cld
        mov     esi,ebp
        add     esi,layer6_ofs
        mov     ecx,layer6_size

        cmp     peshield_ver,ver_02b2
        je      u6_02b2

	cmp	peshield_ver,ver_025
	je	u6_025

u6_02b:	mov     al,byte ptr [ebp+0169h]
        jmp     u6

u6_02b2:mov     al,byte ptr [ebp+0177h]
	jmp	u6

u6_025:	mov	al,byte ptr [ebp+019fh]

u6:     xor     byte ptr [esi], al
        inc     esi
        dec     ecx
        jne     u6

;------ Layer 7
        cld
        mov     esi,ebp
        add     esi,layer7_ofs
        mov     ecx,layer7_size

        cmp     peshield_ver,ver_02b2
        je      u7_02b2

	cmp	peshield_ver,ver_025
	je	u7_025

u7_02b:	mov     al,byte ptr [ebp+0191h]
        jmp     u7

u7_02b2:mov     al,byte ptr [ebp+019fh]
	jmp	u7

u7_025:	mov	al,byte ptr [ebp+01c7h]

u7:	cmp	peshield_ver,ver_025
	je	u7_d025

	xor     byte ptr [esi], al
	jmp	u7_loop

u7_d025:
	add	byte ptr [esi],al

u7_loop:
        inc     esi
        dec     ecx
        jne     u7

;------ Layer 8
        cld
        mov     esi,ebp
        add     esi,layer8_ofs
        mov     ecx,layer8_size

        cmp     peshield_ver,ver_02b2
        je      u8_02b2

	cmp	peshield_ver,ver_025
	je	u8_025

u8_02b:	mov     al,byte ptr [ebp+01b7h]
        jmp     u8
u8_02b2:mov     al,byte ptr [ebp+01c5h]
	jmp	u8
u8_025:	mov	al,byte ptr [ebp+01edh]

u8:     xor     byte ptr [esi], al
        inc     esi
        dec     ecx
        jne     u8


;------ Additional layer inside PESHiELD
        mov     esi,ebp
        add     esi,layer9_ofs
        mov     edi, esi
        mov     ecx,layer9_size

        cmp     peshield_ver,ver_02b2
        je      u9_02b2
        
        cmp	peshield_ver,ver_025
        je	u9_025

u9_02b:	mov     bl,byte ptr [ebp+0357h]
        jmp     u9

u9_02b2:mov     bl,byte ptr [ebp+038ch]
	jmp	u9

u9_025:	mov	bl,byte ptr [ebp+03f1h]

u9:     lodsb
        xor     al, bl
        xor     al, cl
        stosb
        dec     cx
        jne     u9

;###### Decrypt some strings #########################################
        cmp     peshield_ver,ver_02b2
        je      dstr1_02b2

        cmp     peshield_ver,ver_025
        je      dstr1_025


dstr1_02b:
        mov     ebx, dword ptr [ebp+00000F9Ch]
        lea     esi, dword ptr [ebp+00000CF5h]
        jmp     decrypt_strings1

dstr1_02b2:
        mov     ebx, dword ptr [ebp+000011B9h]  ; Decryption key
        lea     esi, dword ptr [ebp+00000E7Eh]  ; Pointer to encrypted data
        jmp     decrypt_strings1

dstr1_025:
        mov     ebx, dword ptr [ebp+00001297h]  ; Decryption key
        lea     esi, dword ptr [ebp+00000F58h]  ; Pointer to encrypted data
        jmp     decrypt_strings1


decrypt_strings1:
        call    decrypt_something               ; See below the ripped procedure
        call    decrypt_something               ; Use ESI and EBX from previous call
        call    decrypt_something
        call    decrypt_something
        call    decrypt_something
        call    decrypt_something

        cmp     peshield_ver,ver_02b2
        je      dstr2_02b2

        cmp     peshield_ver,ver_025
        je      dstr2_025

        mov     ebx, dword ptr [ebp+00000FB0h]
        lea     esi, dword ptr [ebp+00000E71h]
        jmp     decrypt_strings2

dstr2_02b2:
        mov     ebx, dword ptr [ebp+000011CDh]
        lea     esi, dword ptr [ebp+00001026h]
        jmp     decrypt_strings2

dstr2_025:
        mov     ebx, dword ptr [ebp+000012ABh]
        lea     esi, dword ptr [ebp+00001100h]
        jmp     decrypt_strings2


decrypt_strings2:
        call    decrypt_something
        call    decrypt_something
        call    decrypt_something

;###### Decrypt sections in memory ###################################
        cmp     peshield_ver,ver_02b2
        je      key_correct_02b2

	cmp	peshield_ver,ver_025
	je	key_correct_025

        cmp     dword ptr [ebp+04a6h],90909090h
        je      skip_key_correct1

        mov     ebx,sections_start              ; BX points to first section header
        movzx   eax, byte ptr [ebx+0024h]       ; Get section flags
        mov     ah, al
        add     dword ptr [ebp+00000f50h], eax  ; Correct encryption key
skip_key_correct1:
        jmp     get_cryptinfo

key_correct_02b2:
        cmp     dword ptr [ebp+04d8h],90909090h
        je      skip_key_correct2

        mov     ebx,sections_start              ; BX points to first section header
        movzx   eax, byte ptr [ebx+0024h]       ; Get section flags
        mov     ah, al
        add     dword ptr [ebp+00001165h], eax  ; Correct encryption key
skip_key_correct2:
	jmp	get_cryptinfo

key_correct_025:
	cmp	dword ptr [ebp+057ah],90909090h
	je	skip_key_correct3

        mov     ebx,sections_start              ; BX points to first section header
        movzx   eax, byte ptr [ebx+0024h]       ; Get section flags
        mov     ah, al
        add     dword ptr [ebp+00001243h], eax  ; Correct encryption key
skip_key_correct3:


get_cryptinfo:
        cmp     peshield_ver,ver_02b2
        je      getinfo_02b2

        cmp     peshield_ver,ver_025
        je      getinfo_025

getinfo_02b:
        mov     esi, dword ptr [ebp+00000f60h]  ;
        add     esi, ebp                        ;
        mov     ebx, dword ptr [ebp+00000f50h]  ; EBX is ecnryption key
        jmp     decrypt_sections

getinfo_02b2:
        mov     esi, dword ptr [ebp+00001175h]  ; ESI -> ebp+00001268h
        add     esi, ebp                        ;
        mov     ebx, dword ptr [ebp+00001165h]  ; EBX is ecnryption key
	jmp	decrypt_sections


getinfo_025:
        mov     esi, dword ptr [ebp+00001253h]	;
        add     esi, ebp			;
        mov     ebx, dword ptr [ebp+00001243h]  ; EBX is ecnryption key
	jmp	decrypt_sections

decrypt_sections:
        lodsd                                   ; Get section RVA in EAX
        or      eax,eax                         ; End of list?
        jz      ds_exit

        mov     edi, eax                        ; Decrypt start address
        xor     edi, ebx                        ;
        rol     ebx, 1                          ;
        add     ebx, edi                        ;

        lodsd                                   ; Get length of section
        mov     ecx, eax                        ; ECX is length (in dwords)
        xor     ecx, ebx                        ; Decrypt length

        lodsd                                   ; EAX is 2nd encryption key
        add     eax, ebx                        ;
        rol     ebx, 1                          ;

ds_2:   
        push    edi

        push    eax
        xchg    eax,edi
        call    rva2fo                          ; Get file offset for given RVA
        xchg    eax,edi
        pop     eax

        or      edi,edi                         ; Check for NULL pointer (RVA is in
        jz      ds_3                            ; section gaps). If so - don't decrypt

        xor     dword ptr [edi], eax
        xor     dword ptr [edi], ecx
        
ds_3:   pop     edi


	cmp	peshield_ver,ver_025        
	je	ds_3_025
        rol     eax, 02h			; ROL EAX,2 for ver 0.2b and 0.2b2
	jmp	ds_3_loop

ds_3_025:
	rol	eax,03h				; ROL EAX,3 for ver 0.25

ds_3_loop:
        add     eax, ecx
        add     edi, 00000004h
        dec     ecx                             ; ECX is used for decrypting!
        jne     ds_2

        jmp     decrypt_sections
ds_exit:

;###### Rebuild import section #######################################
        cmp     peshield_ver,ver_02b2
        je      isr_02b2

	cmp	peshield_ver,ver_025
	je	isr_025

isr_02b:
        mov     eax,dword ptr [ebp+0f7ch]       ; EAX=import section RVA
        jmp     imports_rebuild
isr_02b2:
        mov     eax,dword ptr [ebp+1195h]       ; EAX=import section RVA
        jmp     imports_rebuild
isr_025:
	mov	eax,dword ptr [ebp+1273h]	; EAX=import section RVA
        jmp     imports_rebuild

imports_rebuild:
        call    rva2fo
        xchg    eax,ebx

is_start:
        mov     edx,dword ptr [ebx+000ch]       ; EBX -> DLL name
        or      edx,edx                         ; NULL pointer?
        jz      is_exit                         ; If so - exit rebuilding of import section

        mov     esi,dword ptr [ebx]             ; ESI=OriginalFirstThunk RVA
        mov     edi,dword ptr [ebx+10h]         ; EDI=FirstThunk RVA
        or      esi,esi                         ; Is OriginalFirstThunk RVA NULL?
        jnz     is_2                            ;
        mov     esi,edi                         ; If NULL, then get FirstThunk RVA

is_2:

        mov     eax,esi
        call    rva2fo
        mov     esi,eax

is_3:
        mov     eax,dword ptr [esi]             ; EAX=pointer to imported function
        or      eax,eax                         ; End of functions for this DLL?
        jz      is_next_dll                     ; Go to process next DLL
        jns     is_4                            ; If named function - go to process it
        movzx   eax,ax                          ; Imported ordinal fn - unencrypted!
        jmp     is_5
is_4:
        inc     eax
        inc     eax

        push    esi

        call    rva2fo
        mov     esi,eax

        push    ebx

        cmp     peshield_ver,ver_02b2
        je      is_41_02b2

	cmp	peshield_ver,ver_025
	je	is_41_025

is_41_02b:
        mov     ebx,dword ptr [ebp+0F8Ch]
        jmp     is_41
is_41_02b2:
        mov     ebx,dword ptr [ebp+11a9h]
	jmp	is_41
is_41_025:
        mov     ebx,dword ptr [ebp+1287h]
	jmp	is_41

is_41:

        call    decrypt_something               ; Decrypt function name

        cmp     peshield_ver,ver_02b2
        je      is_42_02b2

	cmp	peshield_ver,ver_025
	je	is_42_025

is_42_02b:
        mov     dword ptr [ebp+0F8Ch],ebx
        jmp     is_42
is_42_02b2:
        mov     dword ptr [ebp+11a9h],ebx
        jmp	is_42
is_42_025:
        mov     dword ptr [ebp+1287h],ebx
        jmp	is_42

is_42:
        pop     ebx

        pop     esi
is_5:
        add     esi, 00000004
        add     edi, 00000004
        jmp     is_3                            ; Process next function

is_next_dll:
        add     ebx, 00000014h                  ; EDX points to next
        jmp     is_start

is_exit:

;###### Restoring original entry point IP and setting some data in PE header
update_header:
        mov     esi,pe_header_ptr               ; ESI points to PE header

        cmp     peshield_ver,ver_02b2
        je      get_oep_02b2
        
        cmp	peshield_ver,ver_025
        je	get_oep_025

        mov     eax, dword ptr [ebp+00000f54h]  ; EAX points to encrypted OEP
        xor     eax, dword ptr [ebp+00000fa4h]  ; Decrypt OEP
        mov     dword ptr [esi+28h],eax         ; Save new entry point

        mov     eax,dword ptr [ebp+0f7ch]       ; Get Import RVA
        mov     dword ptr [esi+80h],eax         ; Save at directories data
        mov     eax,dword ptr [ebp+0f94h]       ; Get Import section size
        mov     dword ptr [esi+84h],eax         ; Save at PE header
        jmp     header_ok

get_oep_02b2:
        mov     eax, dword ptr [ebp+00001169h]  ; EAX points to encrypted OEP
        xor     eax, dword ptr [ebp+000011C1h]  ; Decrypt OEP
        mov     dword ptr [esi+28h],eax         ; Save new entry point

        mov     eax,dword ptr [ebp+1195h]       ; Get Import RVA
        mov     dword ptr [esi+80h],eax         ; Save at directories data
        mov     eax,dword ptr [ebp+11adh]       ; Get Import section size
        mov     dword ptr [esi+84h],eax         ; Save at PE header
        jmp     header_ok

get_oep_025:
        mov     eax, dword ptr [ebp+00001247h]  ; EAX points to encrypted OEP
        xor     eax, dword ptr [ebp+0000129fh]  ; Decrypt OEP
        mov     dword ptr [esi+28h],eax         ; Save new entry point

        mov     eax,dword ptr [ebp+1273h]       ; Get Import RVA
        mov     dword ptr [esi+80h],eax         ; Save at directories data
        mov     eax,dword ptr [ebp+128fh]       ; Get Import section size
        mov     dword ptr [esi+84h],eax         ; Save at PE header
        jmp     header_ok

; One PESHiELD layer unpacked
header_ok:
        mov     esi,pe_header_ptr               ; ESI points to PE header
        mov	eax,dword ptr [esi+28h]
	call	_wsprintfA, offset nfo_temp_str, offset nfo_entrypoint, eax
	add	esp,000ch
	call	infobox_additem, offset nfo_temp_str, 0

        mov     esi,pe_header_ptr               ; ESI points to PE header
        mov	eax,dword ptr [esi+80h]
	call	_wsprintfA, offset nfo_temp_str, offset nfo_importaddr, eax
	add	esp,000ch
	call	infobox_additem, offset nfo_temp_str, 0

;-------
	cmp	remove_layers,00h		; Check if PESHiELD v0.1x layer removing
	je	go_ask_layer_confirm		; option is turned to ON
	
	cmp	peshield_ver,ver_01b
	je	@@remove_peshield_layer
	cmp	peshield_ver,ver_01c
	je	@@remove_peshield_layer
	cmp	peshield_ver,ver_01d
	je	@@remove_peshield_layer
	jmp	go_ask_layer_confirm

@@remove_peshield_layer:
        cmp     remove_confirm,00h
        je	@@remove_pesh_01_layer
        call    MessageBox, NULL, offset szRemoveConfirm, offset szInfo, \
                MB_YESNO or MB_TASKMODAL or MB_ICONQUESTION
        cmp     eax,IDNO                        ; 'NO' pressed?
        je      go_ask_layer_confirm		; If so - skip unpacking next layer

; Decrease file size by removing the PESHiELD 0.1x section (no resources rebuilding
; is needed for versions 0.1xxx). DANGEROUS hehe ;)
@@remove_pesh_01_layer:
	call	clear_last_section		


go_ask_layer_confirm:
        cmp     layer_confirm,00h
        je      go_unpack_next_layer
        call    MessageBox, NULL, offset szLayerConfirm, offset szInfo, \
                MB_YESNO or MB_TASKMODAL or MB_ICONQUESTION
        cmp     eax,IDNO                        ; 'NO' pressed?
        je      unpack_relocs                   ; If so - skip unpacking next layer
        
go_unpack_next_layer:
        jmp     check_valid_exe                 ; Go check for another PE-SHiELD layer


;###### Unpack relocation items ######################################
unpack_relocs:
	cmp	peshield_ver,ver_02b2		; Only for v0.2b2 (for now)
	jne	reld_exit

	mov	esi, dword ptr [ebp+00001189h]	; 00010000 (reloc RVA)

	or	esi, esi			; Check if relocs exist
	je	reld_exit			; 
	
	mov	edi,pe_header_ptr		; EDI points to PE header
	cmp	esi,dword ptr [edi+00a0h]	; Compare with relocs RVA in PE header
	jne	reld_exit
	
	add	esi, 00000010h			; ESI=reloc_rva+10h (skip fake reloc data)
	call	decompress_relocs		; Relocations decompress (imports&data)

reld_exit:

;###### Write unpacked file to disk ##################################
write_file:

        cmp     calc_pe_chksum,00h
        je      skip_calc_pe_checksum
        call    calc_pe_checksum                ; Calculate PE checksum

skip_calc_pe_checksum:
        cmp     chg_codeflags,00h
        je      skip_chg_codes_flags
        call    change_codesect_flags           ; Change flags of code section

skip_chg_codes_flags:

        call    CreateFileA, offset outfname, GENERIC_WRITE,\
                             NULL, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
        push    eax                             ; Push handle for use with CloseHandle

        call    WriteFile, eax, buffer, f_size, offset write_len, NULL

        call    CloseHandle

        cmp	layers_num,00h
        jz	no_peshield_found

	call	infobox_additem, offset nfo_unpack_ok, 0
	jmp	end_of_unpacking

no_peshield_found:
	call	infobox_additem, offset nfo_unpack_bad, 0

end_of_unpacking:

free_mem_exit:
        call    GlobalFree,buffer

exit:
        popad
        ret
unpack_peshield endp

.data?
relocs_buffer	dd	?

.code
; Decompress reloc items
; ESI points to reloc data
decompress_relocs	proc
	mov	eax,esi
	push	esi

	mov	esi,pe_header_ptr		; ESI points to PE header
	movzx	ecx,word ptr [esi+0006h]	; ECX is sections number
	mov	esi,sections_start		; ESI points to first section header
@@1:	cmp	eax,dword ptr [esi+000ch]	; Check start RVA
	je	@@section_found			;
	jb	@@prev_sect
	add	esi,0028h
	loop	@@1
@@prev_sect:
	sub	esi,0028h
@@section_found:

	mov	eax,dword ptr [esi+0008h]	; EAX=virtual size
	cmp	eax,dword ptr [esi+0010h]	; Compare with physical size
	ja	@@size_ok
	mov	eax,dword ptr [esi+0010h]
@@size_ok:
	shl	eax,02h				; Reloc section size * 4

        call    GlobalAlloc, GMEM_FIXED, eax	; Allocate memory
	mov	relocs_buffer,eax

	mov	edi,eax				; EAX points to unpack buffer
	add	edi,0010h			; Skip 16 bytes

	pop	eax				; EAX points to reloc section
	call	rva2fo
	mov	esi,eax

	call	sub_decompress_relocs		; Decompress imports
	call	sub_decompress_relocs		; Decompress data

	xor	eax,eax				; Set end of list
	stosd					;

;###### Sort reloc items #############################################
;The slowest algo but works OK ;)
	mov	esi,relocs_buffer		; ESI points to table with reloc items
	add	esi,0010h			; Skip empty area
@@sort_1:
	cmp	dword ptr [esi],0000h		; End of array?
	je	@@sort_end

	mov	edi,esi
@@sort_2:
	cmp	dword ptr [edi],0000h		; End of array?
	je	@@sort_3

	mov	eax,dword ptr [esi]		; EAX=A[I]
	cmp	eax,dword ptr [edi]		; A[I] > A[J]
	jle	@@sort_4

	xchg	eax,dword ptr [edi]		; Exchange items
	mov	dword ptr [esi],eax		;

@@sort_4:
	add	edi,0004h			; EDI points to next element
	jmp	@@sort_2
@@sort_3:
	add	esi,0004h			; ESI points to next element
	jmp	@@sort_1

@@sort_end:

;###### Create valid reloc table #####################################
	mov	edi,relocs_buffer		; EDI points to buffer where will be created
						; the valid reloc table

	mov	esi,edi				; ESI points to uncompressed reloc items
	add	esi,0010h			;

@@reloc_new_page:
	push	edi				; Save pointer to start of page
	lodsd					; Get first item as page RVA
	and	ax,0f000h			; Clear low 3 nibbles (reloc offset)
	stosd					; Store as page base
	mov	ebx,eax				; EBX is page base

	mov	ecx,0008h			; ECX=size of page
	add	edi,0004h			; EDI points to first reloc item (type 3)

	or	eax,eax
	jz	@@end_of_relocs

	sub	esi,0004h			; ESI points to previous reloc item

@@reloc_next_item:
	lodsd					; Get reloc item
	or	eax,eax				; End of items?
	jz	@@end_of_relocs			; If so - exit

	mov	edx,eax				; EDX=reloc item
	and	dx,0f000h			; Mask reloc offset
	cmp	edx,ebx				; Compare if it is in the same page
	je	@@reloc_same_page

	pop	ebx				; EI points to start of page
	mov	dword ptr [ebx+0004h],ecx	; Store page size

	sub	esi,0004h			; ESI points to previous item
	jmp	@@reloc_new_page		; Go proceed next page

@@reloc_same_page:
	and	ax,0fffh			; Mask reloc offset (3 nibbles)
	or	ax,3000h			; Set reloc item type to 3 (32 bit delta)

	stosw					; Store at reloc items

	add	ecx,0002h
	jmp	@@reloc_next_item

@@end_of_relocs:
	xor	eax,eax				; Save zero as last element
	stosd					;
	stosd

	add	ecx,0002h

	pop	esi				; EI points to start of page
	mov	dword ptr [esi+0004h],ecx	; Store page size

	sub	edi,relocs_buffer		; EDI=real size of the valid reloc table

        call    GlobalFree, relocs_buffer
        ret
decompress_relocs	endp

;###### Real relocs decompress #######################################
sub_decompress_relocs	proc
	lodsd					; Get base RVA
	stosd					; Store it
	or	eax,eax
	jz	@@end_of_relocs
	mov	ebx,eax				; EBX is reloc base
drl_1:
	lodsb					; Get reloc item type
	movzx	eax,al				; Use it as byte offset

	or	al,al				; End of items?
	jz	@@end_of_relocs

	cmp	al,01h				; Word offset?
	je	drl_word			;
	
	cmp	al,02h				; Dword offset?
	je	drl_dword			;

	cmp	al,03h				; RLE compressed?
	je	drl_rle				;

drl_2:
	add	ebx,eax
	mov	eax,ebx
	stosd
	jmp	drl_1

drl_word:
	lodsw
	movzx	eax,ax
	jmp	drl_2

drl_dword:
	lodsd
	jmp	drl_2

drl_rle:
	lodsb				; Get counter type
	movzx	ecx, al

	or	cl, cl			; Word counter?
	je	drl_6

	cmp	cl, 01h			; Dword counter?
	je	drl_7

	jmp	drl_8			; Byte counter

drl_6:
	lodsw
	movzx	ecx, ax
	jmp	drl_8

drl_7:
	lodsd
	mov	ecx,eax

; RLE decompress with given length
drl_8:
	lodsb
	movzx	edx, al

drl_l1:
	add	ebx,edx
	mov	eax,ebx
	stosd
	loop	drl_l1
	
	jmp	drl_1
@@end_of_relocs:
	ret
sub_decompress_relocs	endp

; Recalculate PE file check sum. Uses the procedure, made by tHE EGOiSTE!
calc_pe_checksum	proc
	call	CalcPESum, buffer, f_size
	jc	@@exit				; If error - leave checksum untouched

	mov	esi,pe_header_ptr		; ESI points to PE header
	mov	dword ptr [esi+0058h],eax	; Save checksum
@@exit:
	ret
calc_pe_checksum	endp

; Change code section flags to E0000020h. BUGGY CODE!
change_codesect_flags   proc
	mov	esi,pe_header_ptr		; ESI points to PE header
	mov	eax,dword ptr [esi+0028h]	; EAX is entry point RVA
	movzx	ecx,word ptr [esi+0006h]	; ECX is sections number
	mov	esi,sections_start		; ESI points to first section header
@@1:	cmp	eax,dword ptr [esi+000ch]	; Check start RVA
	je	@@section_found			;
	jb	@@prev_sect
	add	esi,0028h
	loop	@@1
@@prev_sect:
	sub	esi,0028h
@@section_found:
	mov	dword ptr [esi+0024h],0e0000020h; Change flags
        ret
change_codesect_flags   endp

; Convert RVA in EAX to file offset in EAX. Return NULL if bad RVA!!!
; [section          ][gap][section]     <- File loaded by OS view
;        |-----------------|            <- Decrypt length
; [section          ][section]          <- File layout (as on disk/loaded by unpacker)
;
; if (rva > section_start + section length) and (rva < next_section_start) then EAX=0
rva2fo  proc
        uses    ecx,esi,edi

        mov     esi,pe_header_ptr       ; ESI points to PE header in memory
        movzx   ecx,word ptr [esi+0006h]; ECX=sections number

        movzx   edi,word ptr [esi+14h]  ; Get PE Header Size
        add     edi,18h                 ; Add offset of Flags field
        add     edi,esi                 ; Make EDI = Object Table Address
        mov     sections_start,edi      ; Save for later use

        mov     esi,edi
@@scan_section:
        cmp     eax,dword ptr [esi+000ch]; Compare RVA with section RVA
        jae     @@sect_found

@@go_scan_next_section:
        add     esi,0028h               ; ESI points to next section in memory
        loop    @@scan_section
        jmp     @@wrong_rva

@@sect_found:
        cmp     ecx,0001h
        je      @@its_last_section
        cmp     eax,dword ptr [esi+000ch+0028h] ; Compare with the start RVA of next section
        jae     @@go_scan_next_section

        mov     edi,dword ptr [esi+000ch]; EDI is section start RVA
        add     edi,dword ptr [esi+0010h]; EDI is the end RVA of the section in file
        cmp     eax,edi
        jae     @@wrong_rva


@@its_last_section:
        sub     eax,dword ptr [esi+000ch]; EAX is offset withing section
        add     eax,dword ptr [esi+0014h]; EAX=physical address of section + offset
        add     eax,buffer              ; EAX is offset in our memory buffer!
        ret

@@wrong_rva:
        xor     eax,eax
        ret
rva2fo  endp


; This procedure emulates mutated instruction (only the modifier in AH)
; using the data from AL. Result returned in DL
; Only mutated instructions are marked with *
;  000-add*, 001-or, 010-adc, 011-sbb,
;  100-and, 101-sub*, 110-xor*, 111-cmp
mut_emulate     proc
        xchg    ah,al           ; Correct the data from little endian order

        and     ah,00111000b    ; Mask instruction selector
        shr     ah,03h          ;

        or      ah,ah           ; Is it ADD instruction?
        jz      mut_emul_add

        cmp     ah,05h          ; Is it SUB instruction?
        jz      mut_emul_sub

        cmp     ah,06h          ; Is it XOR instruction?
        jz      mut_emul_xor

        ;
        ; No error handling!
        ;

mut_emul_xor:
        xor     dl,al
        ret

mut_emul_sub:
        sub     dl,al
        ret

mut_emul_add:
        add     dl,al
        ret
mut_emulate     endp


; Decrypt a string at ESI
decrypt_something       proc
decr_smth_1:
        mov     al, byte ptr [esi]
        or      al, al
        je      decr_smth_2
        mov     al, bl
        and     al, 1Fh
        xor     byte ptr [esi], al
        rol     ebx, 04h
        inc     esi
        jmp     decr_smth_1

decr_smth_2:
        inc     esi
        ret
decrypt_something       endp

; Next procedure is written by tHE EGOiSTE. Changed some decimal constants to hex ones
; Thanks, Ego!

;*----------------------------------------------*
; int CalcPESum( *Filebuffer, unsigned int Size); 
;
; Calculates Checksum for PE format files
; (remove PE check and OldSum-filter code to
;  calculate Checksum for other Images)
; Returns: PE Checksum/Carry clear on success
;          NULL       /Carry set   on error
; by tE!//TMG
;*-----------------------------------------------*
CalcPESum proc uses ebx esi edi, lpImage:DWORD, ImageSize:DWORD
        mov     ecx, ImageSize
        shr     ecx, 1
        jc      @@err
        add     ecx, ecx
        jz      @@err           
        shr     ecx, 2
        sbb     edx, edx
        neg     edx
        xor     ebx, ebx
        mov     esi, lpImage
        cmp     word ptr [esi], "ZM"
        jnz     @@err
        mov     eax, [esi+3c]
        add     eax, esi
        cmp     dword ptr[eax], 00004550h
        jnz     @@err
        mov     edi, dword ptr[eax+58h]                  ; original sum
@@l1:   lodsd
        adc     ebx, eax
        loop    @@l1
        adc     ebx, 0
        test    edx, edx
        jz      @@fin   
        xor     eax, eax
        lodsw
        add     ebx, eax
        adc     ebx, 0
@@fin:  mov     eax, ebx
        shr     ebx, 10h
        and     eax, 0FFFFh
        add     eax, ebx
        mov     ebx, eax
        shr     ebx, 10h
        add     eax, ebx
        and     eax, 0FFFFh
;
        mov     ebx, edi
        shr     ebx, 10h                                 ; bx=high word original sum
        mov     ecx, edi

        cmp     ax, cx
        sbb     edx, edx
        neg     edx
        add     edx, ecx
        sub     eax, edx
        cmp     ax, bx
        sbb     edx, edx
        neg     edx
        mov     cx, bx
        add     edx, ecx
        sub     eax, edx
        and     eax, 0FFFFh
        add     eax, ImageSize
        clc
        RET
@@err:  xor     eax, eax
        stc
        RET
CalcPESum endp

;###### Remove last section in PE file ###############################
; Remove last section in the PE file and the result is smaller size. No tags are
; added at the place of the section header info - just simple clear.
clear_last_section	proc
	pushad
	mov	esi,pe_header_ptr

;----- Kill cryptor sections
	dec	word ptr [esi+0006h]		; Decrease number of sections

;----- Find end of sections
        movzx	eax,word ptr [esi+0006h]
        mov	ebx,0028h
        mul	ebx
        movzx	ebx,word ptr [esi+0014h]
        add	esi,ebx
        add	esi,eax
	add	esi,0018h

	mov	edi,esi

	mov	eax,[esi-28h+14h]		; Get physical offset of section before PE-PROT
	add	eax,[esi-28h+10h]		; Add its size to get the total file size
	mov	f_size,eax			; Set write file size

	mov	eax,[esi-28h+0ch]		; Get section RVA
	add	eax,[esi-28h+08h]		; Add virtual size
	mov	esi,pe_header_ptr
	mov	[esi+0050h],eax			; Set image size (checked under WinNT/2k)
	
;----- Clear PE-SHiELD section info in PE header (no shit tags ;)
	mov	ecx,0028h
	xor	al,al
	cld
	rep	stosb

	popad
	ret
clear_last_section	endp


; Add item to the info box (a simple list box). Got the example from win32asm.cjb.net
; written by CRowmAN
infobox_additem	proc	string:dword,color:dword
	pushad
	call	SendMessage,hInfoBox,LB_ADDSTRING,0, string
	push	eax
;	call	SendMessage,hInfoBox,LB_SETITEMDATA,eax,color	; Not used (for now)
	pop	eax
	call	SendMessage,hInfoBox,LB_SETCURSEL,eax,0
;	call	SetFocus,hInfoBox
	popad
	ret
infobox_additem	endp

; Clear the info box
infobox_clear	proc
	call	SendMessage, hInfoBox, LB_RESETCONTENT, 0, 0
	ret
infobox_clear	endp

;###### PESHiELD 0.1b/c/d support routines ###########################

; Check if current layer is an old PESHiELD version (0.1xxx) and decrypt it
; On entry EBP points to entry point. Return in AL result (00h - not found,
; non-zero - found known version and decrypted). Only PESHiELD v0.1beta (the
; first one) is not supported because I still don't have it.
check_old_peshield	proc
	pushad
	call	detect_mutation
	or	al,al
	jz	not_pesh_01
	call	emulate_decryptor
	mov	ebp,mte_real_code		; EBP points to real PESHiELD layer

; Check for PESHiELD 0.1d
	cmp	dword ptr [ebp+006fh],0104b58dh	; lea esi,[ebp+sections_info]
	jne	not_pesh_01d
	cmp	dword ptr [ebp+0073h],0bad0000h	; lodsd; or eax,eax
	jne	not_pesh_01d

	mov	peshield_ver,ver_01d
	lea	esi, dword ptr [ebp+00000104h]	; ESI points to sections decrypt info
	jmp	@@decrypt_sections

; Check for PESHiELD 0.1b
not_pesh_01d:
	cmp	dword ptr [ebp+005eh],00e5b58dh	; lea esi,[ebp+sections_info]
	jne	not_pesh_01b
	cmp	dword ptr [ebp+0062h],0bad0000h	; lodsd; or eax,eax
	jne	not_pesh_01b

	mov	peshield_ver,ver_01b
	lea	esi, dword ptr [ebp+000000e5h]	; ESI points to sections decrypt info
	jmp	@@decrypt_sections

; Check for PESHiELD 0.1c
not_pesh_01b:
	cmp	dword ptr [ebp+005eh],00f4b58dh	; lea esi,[ebp+sections_info]
	jne	not_pesh_01c
	cmp	dword ptr [ebp+0062h],0bad0000h	; lodsd; or eax,eax
	jne	not_pesh_01c

	mov	peshield_ver,ver_01c
	lea	esi, dword ptr [ebp+000000f4h]	; ESI points to sections decrypt info
	jmp	@@decrypt_sections

; Not known PESHiELD 0.1xxx found! Please, send me the file if this occures
not_pesh_01c:
	mov	peshield_ver,ver_01unknown
	popad
	mov	al,ver_01unknown
	ret

not_pesh_01:
	popad
	xor	al,al
	ret

; Decrypt sections (PESHiELD 0.1b/c/d compatible)
@@decrypt_sections:

pesh01d_d1:
	lodsd					; Get length
	or	eax, eax
	je	pesh01d_dexit
	mov	ecx, eax			; Move length in ECX
	
	lodsd					; Get section RVA
	call	rva2fo
	mov	edi,eax				; EDI points to section in memory

	or	eax,eax				; Check if bad pointer and skip to
	jz	pesh01d_next_sect		; next section

	lodsb					; Get first decryption byte
	mov	dh, al
	lodsb					; Get second decryption byte
	mov	dl, al
pesh01d_d2:
	mov	al, byte ptr [edi]
	sub	al, dl
	xor	al, cl
	xor	al, dh
	mov	byte ptr [edi], al
	add	dh, dl
	xor	dl, dh
	inc	edi
	loop	pesh01d_d2

	jmp	pesh01d_d1

pesh01d_next_sect:
	lodsw
	jmp	pesh01d_d1

pesh01d_dexit:

;----- Get Original Entry Point
	cmp	peshield_ver,ver_01b
	je	@@get_oep_v01b

	cmp	peshield_ver,ver_01d
	jne	@@get_eop_v01c
	mov	eax,dword ptr [ebp+00eah]	; Get add value
	mov	bh,byte ptr [ebp+00e5h]		; High byte
	jmp	@@set_oep
	

@@get_eop_v01c:
	cmp	peshield_ver,ver_01c
	jne	not_pesh_01			; ERROR EXIT!
	mov	eax,dword ptr [ebp+00dah]	; Get add value
	mov	bh,byte ptr [ebp+00d5h]		; High byte
	jmp	@@set_oep


@@set_oep:
	and	eax,00ffffffh			; Mask low 3 bytes
	shl	ebx,10h				; Move it 16 bits to become high byte
	and	ebx,0ff000000h
	or	eax,ebx

	mov	esi,pe_header_ptr		; ESI points to PE header
	add	dword ptr [esi+0028h],eax	; Calculate new entry point

@@exit:
	popad
	mov	al,peshield_ver
	ret

@@get_oep_v01b:
	mov	esi,pe_header_ptr		; ESI points to PE header
	mov	ebx,dword ptr [esi+0028h]	; EBX is entry point RVA

	mov	eax,ebx				; Calculate the offset of the
	call	rva2fo                          ; non-polymorph layer inside
	neg	eax				; PESHiELD 0.1b layer
	add	eax,ebp                         ;

	add	eax,ebx				; Add the PESHiELD layer RVA
	add	eax,dword ptr [ebp+00cdh]	; Add the offset of OEP
	mov	dword ptr [esi+0028h],eax	; Set the new entry point
	jmp	@@exit
check_old_peshield	endp

;###### Detect PESHiELD 0.1d mutation layer ##########################
.data

; The following array contains the detected mutated instructions. Each element is two
; bytes long and has the following structure:
; 	1st byte	- emulated operation
; 	2nd byte	- data used to decrypt
; These are the valid opcodes:
;	00h	- end of operations
;
; --- Add immediate value to register
;	01h	- add reg,value	80 xx
;	02h	- sub reg,value	80 xx
;	03h	- xor reg,value	80 xx
;
; where the register and the instruction modifier are in second byte
;  7 6 5 4 3 2 1 0
; +-+-+-+-+-+-+-+-+
; | | | | | | | | |
; +-+-+-+-+-+-+-+-+
;  | | | | | | | |
;  | | | | | +-+-+----- Reg where (000-al,001-cl,010-dl,011-bl,100-ah,101-ch,110-dh,111-bh)
;  | | +-+-+----------- Instruction modifier - shows which instruction is
;  | |                  used: 000-add*, 001-or, 010-adc, 011-sbb,
;  | |                        100-and, 101-sub*, 110-xor*, 111-cmp
;  | |                  Only marked with * are used
;  +-+----------------- Address method (11h if R/M is used as reg selector)
;
; --- Add the low byte of counter (reg2) to reg (2nd byte is fake)
;	11h	- add reg,reg2	02 xx
;	12h	- sub reg,reg2	2a xx
;	13h	- xor reg,reg2	32 xx
;
; where 1st reg and 2nd reg are encoded in second byte:
;  7 6 5 4 3 2 1 0
; +-+-+-+-+-+-+-+-+
; | | | | | | | | |
; +-+-+-+-+-+-+-+-+
;  | | | | | | | |
;  | | | | | +-+-+----- Reg2 where (000-al,001-cl,010-dl,011-bl,100-ah,101-ch,110-dh,111-bh)
;  | | +-+-+----------- Reg1 where (000-al,001-cl,010-dl,011-bl,100-ah,101-ch,110-dh,111-bh)
;  +-+----------------- Address method (11h if R/M is used as reg selector)

em_array	db	50h dup(?)
em_array_len	equ	$-em_array

mte_decr_len	dd	?	; Length of data to be decrypted
mte_decr_ofs	dd	?	; Offset to start the decryption from
mte_decr_end	dd	?	; End address of mutated decryptor
mte_decr_dir	db	?	; Decrypt direction (00h - decrease, 01h - increase)
mte_real_code	dd	?	; Offset of real PESHiELD code (after mutated layer)

.code
; Emulate decryption using array with emulation instructions
; USE IT ONLY AFTER SUCCESSFULL DETECTION AND WITH VALID EMULATION ARRAY!
emulate_decryptor	proc
	pushad

	mov	ecx,mte_decr_len	; Length
	mov	edi,mte_decr_ofs	; End offset of decrypt area (decrypt downwards)

emul_decr_1:
	mov	al,byte ptr [edi]	; Get byte from decrypt data
	mov	ah,cl			; AH is low byte of counter!!

	call	mutation_emulate	; Emulate all decrypt actions on data in AL

	mov	byte ptr [edi],al

emul_decr_loop:
	dec	edi
	dec	ecx
	jnz	emul_decr_1

	inc	edi			; Store address of real PESHiELD layer
	mov	mte_real_code, edi	; (only the beginning uses different register)

	popad
	ret
emulate_decryptor	endp

; Emulate all decrypt actions on data in AL and low byte of counter in AH.
; Returns result in AL
mutation_emulate	proc
	uses	esi,ebx
	
	lea	esi,em_array
mut_emul_1:
	cmp	word ptr [esi],0000h		; Check if end of array
	je	mut_emul_exit			; If so - exit

	mov	bl,byte ptr [esi]		; BL is emulated instruction

; ADD reg,value
	cmp	bl,01h
	jne	mutem_1
	add	al,byte ptr [esi+01h]		; Add with value
	jmp	mut_emul_loop

; SUB reg,value
mutem_1:
	cmp	bl,02h
	jne	mutem_2
	sub	al,byte ptr [esi+01h]		; Add with value
	jmp	mut_emul_loop

; XOR reg,value
mutem_2:
	cmp	bl,03h
	jne	mutem_3
	xor	al,byte ptr [esi+01h]		; Add with value
	jmp	mut_emul_loop

; ADD reg1,reg2
mutem_3:
	cmp	bl,11h
	jne	mutem_4
	add	al,ah
	jmp	mut_emul_loop

; SUB reg1,reg2
mutem_4:
	cmp	bl,12h
	jne	mutem_5
	sub	al,ah
	jmp	mut_emul_loop

; XOR reg1,reg2
mutem_5:
	cmp	bl,13h
	jne	mutem_6
	xor	al,ah
	jmp	mut_emul_loop

; Unrecognized instruction (wrong array value!)
mutem_6:

mut_emul_loop:
	add	esi,0002h
	jmp	mut_emul_1

mut_emul_exit:
	ret
mutation_emulate	endp


; Decryptor has this structure:
;code_start:
;		call	next_line
;next_line:
;		<junk>
;		pop	<reg1>
;		<junk>
;		add	<reg1>,offset jmp_1-next_line	; No junk between these
;		jmp	<reg1>				; two lines (I am not 100% sure)
;jmp_1:
;		<junk>
;		mov	<reg2>,value	; Move some value in counter register
;		<junk>
;		add	<reg1>,value	; Reg1 is used as pointer register
;		<junk>
;		*op*	<reg2>,value	; Correct counter register (add,sub,xor)
;					; Result is length of real PESHiELD 0.1d + 
;					; sections decrypt info (RVA, size, key)
;		<junk>
;loop_1:				; No junk bytes here
;		mov	reg3,[reg1]	; Get *byte* value (8A 1x)
;		<junk>
;		*op*	reg3,value	; Some operations on byte value that will be decrypted
;		*op*	reg3,reg2	; Operation on byte value with low byte of counter
;		*op*	reg3,value	; These instructions are in random order but always
;		*op*	reg3,value	; sequential???
;		<junk>
;		dec	reg1
;		<junk>
;		dec	reg2
;		<junk>
;		jnz	loop_1


; Detect and emulate PESHiELD 0.1d mutated decryption layer
; On entry EBP contains the offset in memory of entry point
detect_mutation	proc
	pushad
	mov	esi,ebp				; ESI points to PESHiELD layer

	cmp	dword ptr [esi],000000e8h	; Check for PESHiELD layer start
	jne	detm_err_exit
	cmp	byte ptr [esi+0004h],00h	;
	jne	detm_err_exit

	cld

;###### Scan for JMP reg #############################################
; JMP reg
; FF Ex where Ex is: 11100xxx 
; xxx is: 000-eax,001-ecx,010-edx,011-ebx,100-esp,101-ebp,110-esi,111-edi
	mov	ecx,0200h			; Max scan length
	add	esi,0005h			; Skip first instruction (CALL next_line)
detm_1:
	cmp	byte ptr [esi],0ffh		; Check for first byte of instruction
	je	detm_found_jmp_reg
detm_2:
	inc	esi
	loop	detm_1
	jmp	detm_err_exit

detm_found_jmp_reg:
	mov	al,byte ptr [esi+0001h]		; AL is instr modifier
	mov	ah,al
	and	ah,11111000b			; Mask instr selector
	and	al,00000111b			; Mask used register
	cmp	ah,0e0h				; Is it JMP <reg> instr?
	jne	detm_2

;###### Check for ADD <reg>,constant #################################
	cmp	byte ptr [esi-0006h],81h
	jne	detm_2

	mov	bl,byte ptr [esi-0005h]
	mov	bh,bl
	and	bx,0f807h			; BH=instr; BL=reg
	cmp	bh,0c0h				; Is it ADD <reg>,constant ?
	jne	detm_2

	cmp	al,bl				; Check if both instructions use same reg
	jne	detm_2

	mov	eax,dword ptr [esi-0004h]	; EAX is the ADD constant
	add	eax,ebp				; EAX=start+jmp_add+1st_instr_len
	add	eax,0005h			; <- CALL next_line instr length

	sub	eax,esi				; EAX=jmp_offset-jmp_instr_address
	cmp	eax,0002h			; If EAX points to next instr after JMP
	jne	detm_2				; then OK, else not found

;###### PESHiELD 0.1d mutation layer successfully detected! ##########
	add	esi,0002h			; Skip JMP <reg> instruction

	mov	edi,esi				; ESI is the offset of mutated decryptor
; Find the ADD <reg1>,value. Note that BL contains the found JMP reg (which must be the same)
detm_3:
	cmp	byte ptr [esi],81h
	je	detm_add_found
detm_4:
	inc	esi
	loop	detm_3
	jmp	detm_err_exit			; Safe exit (if unknown decryptor!)
	
detm_add_found:
	mov	al,byte ptr [esi+01h]		; Get instruction modifier
	mov	ah,al
	and	ax,0f807h			; AH=instr; AL=reg
	cmp	ah,0c0h				; Is it ADD <reg>,constant ?
	jne	detm_4

	cmp	al,bl				; JMP reg = ADD reg, const?
	jne	detm_4

	mov	eax,dword ptr [esi+02h]		; Get ADD reg,<VALUE>
	add	eax,edi				; EAX=offset of decrypted part

	mov	mte_decr_ofs,eax		; Save it for later use

;----- Scan for JNE instruction to find what is the decrypt length
	push	esi ecx
	add	esi,0002h
detm_find_jne:
	cmp	word ptr [esi],850fh
	je	detm_jne_found
	inc	esi
	loop	detm_find_jne
	pop	ecx esi
	jmp	detm_4				; If not found - search again for ADD

detm_jne_found:
	mov	edx,dword ptr [esi+02h]		; EDX is JMP offset
	test	edx,edx				; Check if negative JMP
	jns	detm_find_jne			; If not - scan again

	add	edx,esi				; EDX=absolute JNE address
	add	edx,0006h			; Fix with JNE length!

	cmp	byte ptr [edx],8ah		; Check if MOV <reg3>,[reg2] at JNE address
	jne	detm_find_jne

	mov	bh,byte ptr [edx+01h]		; Get modifier byte
	and	bh,07h				; Mask [reg2]
	cmp	bh,bl				; Is it the same as pointer reg?
	jne	detm_find_jne

	mov	bh,byte ptr [edx+01h]		; Get modifier byte
	shr	bh,03h				; Get REG3 (byte value to decrypt)
	and	bh,07h				; Mask it

	mov	mte_decr_end,esi
	neg	esi				; Calculate length
	add	esi,mte_decr_ofs		;
	sub	esi,0005h			; Correct with JNE instruction length - 1
	mov	mte_decr_len,esi		; Set decrypt length for emulator

	pop	ecx esi

;###### Start to fill the decryptor table ############################
; BH contains VALUE_TO_DECRYPT register (REG3)
; BL contains POINTER register (REG1)
; !must be added counter recognition for strong recognition

	add	edx,0002h			; Update EDX to point to next instruction

	mov	esi,edx				; ESI points to scan area

	mov	ecx,mte_decr_end		; ECX will contain mutated decryptor length
	sub	ecx,edx				; that will be scanned for decrypt instructions

	lea	edi,em_array			; EDI points to array with emulated instr	


detm_get_instr:

;----- MOV [REG1],REG3
	cmp	byte ptr [esi],88h	; Check if MOV [reg1],reg3
	jne	detm_get_1

	mov	al,byte ptr [esi+01h]	; Get instruction modifier

	mov	ah,al			; It will be used later
	mov	dl,al			;

	and	ah,11000000b		; Mask type of instruction
	jnz	detm_get_1		; If not MOV [dword_reg],byte_reg - skip it

	shr	al,03h			; Mask REG3 (decrypt reg)
	and	al,07h			;
	cmp	al,bh			; Same VALUE_REG regs?
	jne	detm_get_1		;

	and	dl,07h			; Mask REG1 (pointer)
	cmp	dl,bl			; Same pointer regs?
	jne	detm_get_1		;

	jmp	detm_get_exit		; Exit processing (maybe that is wrong)

;----- *OP* REG3,VALUE
detm_get_1:
	cmp	byte ptr [esi],80h
	jne	detm_get_2

	mov	al,byte ptr [esi+01h]	; Get modifier byte
	test	al,11000000b		; Check if R/M is used as register and bytes are used
	jz	detm_get_doloop		; If not - bad opcode

	mov	ah,al			; Get DECRYPT_REG
	and	al,07h			;
	
	cmp	al,bh			; Check if the same as in (mov AL,[edx])
	jne	detm_get_doloop		; If not - bad code

	and	ah,00111000b		; Mask instruction modifier
	shr	ah,03h			;

        or      ah,ah           	; Is it ADD instruction?
        jz      detm_get_add

        cmp     ah,05h          	; Is it SUB instruction?
        jz      detm_get_sub

        cmp     ah,06h          	; Is it XOR instruction?
        jz      detm_get_xor

	jmp	detm_get_doloop		; Skip others

detm_get_add:
	mov	ah,byte ptr [esi+02h]	; Get data byte
	mov	al,01h
	stosw
	inc	esi			; Skip instruction (2+1 bytes)
	inc	esi			;
	jmp	detm_get_doloop

detm_get_sub:
	mov	ah,byte ptr [esi+02h]	; Get data byte
	mov	al,02h
	stosw
	inc	esi			; Skip instruction (2+1 bytes)
	inc	esi			;
	jmp	detm_get_doloop

detm_get_xor:
	mov	ah,byte ptr [esi+02h]	; Get data byte
	mov	al,03h
	stosw
	inc	esi			; Skip instruction (2+1 bytes)
	inc	esi			;
	jmp	detm_get_doloop

;----- ADD REG3,REG2
detm_get_2:
	cmp	byte ptr [esi],02h
	jne	detm_get_3

	mov	al,byte ptr [esi+01h]	; Get modifier
	call	chk_op_reg_cnt		; Check if same regs for DECRYPT and COUNTER
	or	al,al
	jz	detm_get_doloop		; If false - skip instruction

	mov	al,11h			; Emulation opcode
	stosb				; Save it
	stosb				; Save fake byte (unused)

	inc	esi			; Skip this instruction (1+1 bytes)
	jmp	detm_get_doloop

;----- SUB REG3,REG2
detm_get_3:
	cmp	byte ptr [esi],2ah
	jne	detm_get_4

	mov	al,byte ptr [esi+01h]	; Get modifier
	call	chk_op_reg_cnt		; Check if same regs for DECRYPT and COUNTER
	or	al,al
	jz	detm_get_doloop		; If false - skip instruction

	mov	al,12h			; Emulation opcode
	stosb				; Save it
	stosb				; Save fake byte (unused)

	inc	esi			; Skip this instruction (1+1 bytes)
	jmp	detm_get_doloop

;----- XOR REG3,REG2
detm_get_4:
	cmp	byte ptr [esi],32h
	jne	detm_get_5

	mov	al,byte ptr [esi+01h]	; Get modifier
	call	chk_op_reg_cnt		; Check if same regs for DECRYPT and COUNTER
	or	al,al
	jz	detm_get_doloop		; If false - skip instruction

	mov	al,13h			; Emulation opcode
	stosb				; Save it
	stosb				; Save fake byte (unused)

	inc	esi			; Skip this instruction (1+1 bytes)
	jmp	detm_get_doloop

;----- Unrecognized instruction (do nothing)
detm_get_5:

detm_get_doloop:
	inc	esi			; Skip this opcode
	loop	detm_get_instr		; Process all instructions

detm_get_exit:
	xor	ax,ax			; Set end of emulated instructions in array
	stosw				;

detm_exit:
	popad
	mov	al,01h
	ret

detm_err_exit:
	popad
	xor	al,al
	ret
detect_mutation	endp

; Check if registers in (xor AL,CL) registers are the same used in decrypt loop.
; DECRYPT_REG is in BH. POINTER_REG is in BL
; Returns in AL
;	00h - False
;	01h - True
chk_op_reg_cnt	proc
	test	al,11000000b		; Check if R/M is used as register and byte are used
	jz	chk_op_reg_bad		; If one of these bits are zero then bad code

	mov	ah,al			; Copy it

	shr	ah,03h			; Decrypt reg
;	and	ah,07h			;
;	and	al,07h			; Counter reg (not used for now)
	and	ax,0707h		; The same as above but shorter

	cmp	ah,bh			; Compare decrypt regs
	jne	chk_op_reg_bad

	mov	al,01h
	ret

chk_op_reg_bad:
	xor	al,al
	ret
chk_op_reg_cnt	endp

        end     start